# Math in Motion

by Alexandra Cheng & Oskar Garcia 


## Early demo – Summer 2019
Math in Motion (MiM) is a modern interface for working with math on the web. It has a short learning curve and makes it easier to input, edit, and display math on the screen. Since it’s built with core web technologies, it can be used by anyone with a browser.

Github repository: https://github.com/math-in-motion/early-demo

Try it out for yourself at: https://math-in-motion.github.io/early-demo/

Your feedback is golden! Let us know what you think of the project: [Feedback form](https://docs.google.com/forms/d/e/1FAIpQLSfvj-Rl70SucoTN3Rzo8iyYSsTeZfxU5GTdxMHNvCe0FKzrZQ/viewform)


## Core features

* Easily type and edit complex math expressions in real time
* Display the sequence of steps taken to solve math problems
* Copy/Paste functionality similar to regular text
* Easily jump from math mode to regular text mode
* Shortcuts for superscript and subscript
* Basic syntax highlighting for common math symbols


## Technologies and libraries used

* HTML, CSS, and JavaScript
* [MathQuill](http://mathquill.com/)
* [Anime.js](https://animejs.com/)


## Potential features

* Keyboard shortcuts for navigating and editing complex mathematical expressions
* Exporting to multiple formats like PDF and JSON
* Context-aware syntax highlighting
* Semantic search
* Autocomplete for common formulas and expressions
* Undo functionality
* Toolstips
* Display animations and slideshows
* Implementing a database for storing multiple MiM projects
* API for integrating MiM projects with p5.js sketches

## Acknowledgements

This project was made possible by [Google Summer of Code 2019](https://summerofcode.withgoogle.com/) and the [Processing Foundation](https://processing.org/). We're extremely thankful for the support of our incredible mentors [Ellen Nickles](https://ellennickles.site/) and Gregory Benedis-Grab. Without their insights, this project wouldn't have been a success. 

